package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.bag.ListVisitorBag;
import dev.peerat.parser.visitor.bag.VisitorBag;

public class MethodCallValue extends Value{
	
	private Value base;
	private Token generic;
	private Token token;
	private List<Value> parameters;
	
	public MethodCallValue(Value base, Token generic, Token token, List<Value> parameters){
		this.base = base;
		this.generic = generic;
		this.token = token;
		this.parameters = parameters;
	}
	
	public Value base(){
		return this.base;
	}
	
	public Token getGeneric(){
		return this.generic;
	}
	
	public Token getToken(){
		return token;
	}
	
	public List<Value> getParameters(){
		return this.parameters;
	}

	@Override
	public void build(Builder builder) throws Exception {
		
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(JavaVisitor<?> visitor){
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new ListVisitorBag();
		bag.compute(this.base.visit(visitor).toList().toArray());
		if(this.parameters != null)
			for(Value value : this.parameters){
				bag.compute(value.visit(visitor).toList().toArray());
			}
		return bag;
	}

}
