package dev.peerat.parser.java.visitor;

import dev.peerat.parser.java.AnnotationClass;
import dev.peerat.parser.java.ClassBase;
import dev.peerat.parser.java.Function;
import dev.peerat.parser.java.Import;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Operation;
import dev.peerat.parser.java.Variable;
import dev.peerat.parser.java.value.Value;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.bag.VisitorBag;

public abstract class JavaVisitor<T extends JavaElement> extends Visitor<JavaElement>{
	
	public static <T extends JavaElement>  JavaVisitor<T> base(JavaVisitor<T> visitor){
		return visitor;
	}

	public static JavaVisitor<JavaElement> allJavaElement(){
		return null;
	}
	
	public static JavaVisitor<ClassBase> allClassBase(){
		return null;
	}
	
	public static JavaVisitor<dev.peerat.parser.java.Class> allClass(){
		return null;
	}
	
	public static JavaVisitor<JavaElement> allInterface(){
		return null;
	}
	
	public static JavaVisitor<JavaElement> allEnum(){
		return null;
	}
	
	public static JavaVisitor<AnnotationClass> allAnnotationClass(){
		return null;
	}
	
	public static JavaAnnotationVisitor allAnnotation(){
		return new JavaAnnotationVisitor();
	}
	
	public static JavaVisitor<Variable> allVariable(){
		return null;
	}
	
	public static JavaVisitor<Function> allFunction(){
		return null;
	}
	
	public static JavaVisitor<Value> allValue(){
		return null;
	}
	
	public static JavaVisitor<Operation> allOperation(){
		return null;
	}
	
	public static JavaVisitor<Import> allImport(){
		return null;
	}
	
	private Class<?> type;
	
	JavaVisitor(Class<?> type){
		this.type = type;
	}
	
	public boolean canVisit(Class<?> type){
		return this.type.isAssignableFrom(type);
	}
	
	public VisitorBag visit(Object element){
		return visitElement((T) element);
	}
	
	public abstract VisitorBag visitElement(T element);
}